#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <sys/time.h>

void logger_printf(const char *color, const char *file, const char *func, int line, const char *fmt, ...) {
    time_t curr_time = time(NULL);
    int len = 32;
    char date[len];
    struct timeval t;
    gettimeofday(&t, NULL);
    strftime(date, len - 1, "%y-%m-%d-%H:%M:%S", localtime(&curr_time));
    date[len - 1] = '\0';
    len = 64;
    char time_str[len];
    sprintf(time_str, "%s.%03d", date, t.tv_usec / 1000);
    time_str[len - 1] = '\0';

    FILE *out = stdout;
    fprintf(out, "%s%s %s %s-%s:%d ", color, "[FACE-SDK]", time_str, file, func, line);
    va_list args;
    va_start(args, fmt);
    vfprintf(out, fmt, args);
    va_end(args);
    fflush(out);
}